/**
 *
 *  Author(s)...: Pashgan    http://ChipEnable.Ru
 *  Target(s)...: любой микроконтроллер mega
 *  Compiler....: IAR 5.11A
 *  Description.: Заготовка для событийной системы на таблицах
 *  Data........: 30.09.12
 *
 */

/* Define to prevent recursive inclusion -------------------------------------*/
#pragma once
#ifndef EVENT_SYSTEM_H
#define EVENT_SYSTEM_H

#include <avr/io.h>
#include "common.h"
#include "list_event.h"

/* вместимость буфера очереди событий */
#define SIZE_BUF 20

void ES_Init(es_state_t init_state);    /* инициализация */
es_state_t ES_GetState(void);           /* взять код состояния */
void ES_SetState(es_state_t new_state); /* установить код состояния */
es_event_t ES_GetEvent(void);           /* взять код события */
void ES_PlaceEvent(es_event_t event);   /* разместить событие */
void ES_Dispatch(es_event_t event);     /* вызов диспетчера */

/**
 * ES function prototypes
 */
void dotOnPersistent(void);
void dotOn(void);
void dotOff(void);
void showTime(void);
void showWDM(void);
void showYear(void);

#ifdef USE_BRIGHT_CONTROL
void showBright(void);
void incBright(void);
void decBright(void);
#endif

void setTimeShow(void);
void setTimeBegin(void);
void setHHBegin(void);
void setHHInc(void);
void setHHDec(void);
void setMMBegin(void);
void setMMInc(void);
void setMMDec(void);
void setTimeEnd(void);

void setDateBegin(void);
void setDateEnd(void);
void setWDMShow(void);
void setYearShow(void);
void setWDayBegin(void);
void setMDayBegin(void);
void setMonthBegin(void);
void setYearBegin(void);
void setIncWDay(void);
void setIncMDay(void);
void setIncMonth(void);
void setIncYear(void);
void setDecWDay(void);
void setDecMDay(void);
void setDecMonth(void);
void setDecYear(void);

#endif /* EVENT_SYSTEM_H */
